/*
 * lxcall-e.l.c
 * Copyright (C) 2012, 2013, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxcall-types.h>

int
_libx1f4i0_lxcall_side_line(void *context, unsigned bits, const void *screen,
			    struct x1f4_linetext_type **linetext, void **args,
			    unsigned count, const struct line_type *line_data)
{
    struct x1f4_linetext_type *linetext_data;

    linetext_data = *linetext;

    while (count) {
	linetext_data->context = context;

	linetext_data->function = line_data->function;

	line_data->line(screen, linetext_data, args);

	linetext_data++;

	line_data++;

	count--;
    }

    *linetext = linetext_data;

    return 0;
}
