/*
 * lxcall-e.o.c
 * Copyright (C) 2011-2015, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>
#include <lxcall-defs.h>

int
_libx1f4i0_lxcall_slip_call(void **input, void *side, unsigned offset,
			    unsigned bits,
			    struct x1f4_linetext_type **linetext,
			    struct x1f4_linetext_type *linetext_slip,
			    void **subtext)
{
    int *args;
    struct x1f4_function_type *function_data;
    struct x1f4_linetext_type *linetext_data;
    unsigned count, flags;
    void **used;

    function_data = side;

    linetext_data = *linetext;

    count = function_data->count - offset;

    flags = linetext_data->function.flags;

    do {
	if (flags & (X1f4_E4_LINK_PASS | X1f4_E4_POST_TYPE)) {
	    flags |= X1f4_E4_POST_TYPE;
	} else {
	    if (linetext_data->function.count) {
	    } else {
		args = (void *) (function_data->args + offset);
		if (1) {
		    break;
		}
	    }
	}

	if (bits & POST_ARGS) {
	    int *line;
	    const int *plot, *text;
	    unsigned class, i, scale;

	    args = (int *) function_data->args;
	    line = args;
	    plot = linetext_data->function.args;
	    class = linetext_data->function.count;
	    scale = count - class;
	    text = function_data->args + class;
	    i = class;
	    for (; i; i--) {
		int slip;

		slip = *plot++;
		*line++ = slip == X1f4_E4_SLIP ? *(text - i) : slip;
	    }
	    if (flags & X1f4_E4_POST_TYPE) {
		line += scale;
		memcpy(line, plot, class * sizeof(int));
	    }
	} else {
	    int *line;
	    const int *plot, *text;
	    unsigned class, i, scale;

	    args = (void *)
		(bits & POST_LINE ? linetext_slip : linetext_slip + 1);
	    line = args;
	    plot = linetext_data->function.args;
	    class = linetext_data->function.count;
	    scale = count - class;
	    text = function_data->args + offset + class;
	    i = class;
	    for (; i; i--) {
		int slip;

		slip = *plot++;
		*line++ = slip == X1f4_E4_SLIP ? *(text - i) : slip;
	    }
	    memcpy(line, text, scale * sizeof(int));
	    if (flags & X1f4_E4_POST_TYPE) {
		line += scale;
		memcpy(line, plot, class * sizeof(int));
		line += class;
		memcpy(line, text + count + offset, scale * sizeof(int));
	    }
	}
    } while (0);

    if (bits & POST_LINE) {
	linetext_slip = linetext_data;
    } else {
	*linetext_slip = *linetext_data;
    }

    linetext_slip->function.args = args;
    linetext_slip->function.count = count;
    linetext_slip->function.flags =
	flags & ~(X1f4_E4_SIDE_LIST | X1f4_E4_SLIP_LIST);

    used = input[-1];

    used[X1f4_E4_RENDITION] = &linetext_slip->function;

    if (0) {
    } else {
	*linetext = linetext_slip;
	*subtext = (void *) linetext_data->context;
    }

    return 0;
}
