/*
 * lxdash-k.h.c
 * Copyright (C) 2008-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdash_h_keeping(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxdash_type *dxdash_data;
    void *data;

    cxbend_data = context;

    dxdash_data = I_LINE(input[0]);

    status = cxbend_data->pick(dxdash_data->dash, &data);
    if (status) {
	if (status ^ X1f4_BQFSET_DECK_ERROR) {
	    status = _libx1f4i0_lxdash_stat_line(cxbend_data->line, 0, status);
	} else {
	    l_MODE(0, output);
	    if (1) {
		status = 0;
	    }
	}
    } else {
	l_MODE(1, output);
	l_MODE(((struct effect_type *) data)->mode, input[1]);
    }

    return status;
}
