/*
 * lxdata-l.s.q.c
 * Copyright (C) 2008-2010, 2014, 2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>
#include <lxcall.h>
#include <lxdata-inter.h>
#include <lxdata-types.h>

#define I_DATA(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))

#define l_TEXT(e, output) \
    {									      \
	X1f4_E4_C_TEXT *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

#define lxdata(lxdata) \
    ((struct lxdata_type *) (lxdata))

int
_libx1f4i0_lxdata_sqlogique(void *context, void *output, void **input)
{
    int status;

    do {
	X1f4_E4_C_MODE lead, ever;
	char *data;
	struct dxdata_type *dxdata_data;
	unsigned size, unit;
	void *text;

	dxdata_data = I_DATA(input[0]);

	size = dxdata_data->length;

	lead = I_MODE(input[1]);

	if (lead < 0) {
	    if ((X1f4_E4_C_MODE) size < -lead) {
		status = _libx1f4i0_lxdata_stat_deck(context, size, -lead);
		if (1) {
		    break;
		}
	    } else {
		lead = size + lead;
	    }
	} else {
	    if (lead < size) {
	    } else {
		status = _libx1f4i0_lxdata_stat_deck(context, size, lead);
		if (1) {
		    break;
		}
	    }
	}

	ever = I_MODE(input[2]);

	if (ever < 0) {
	    if ((X1f4_E4_C_MODE) size < -ever) {
		status = _libx1f4i0_lxdata_stat_deck(context, size, -ever);
		if (1) {
		    break;
		}
	    } else {
		ever = size + ever;
	    }
	} else {
	    if (ever < size) {
	    } else {
		status = _libx1f4i0_lxdata_stat_deck(context, size, ever);
		if (1) {
		    break;
		}
	    }
	}

	data = (void *) dxdata_data->string;

	if (ever < lead) {
	    size -= lead;
	    unit = size + ever + 1;
	} else {
	    unit = ever - lead + 1;
	}

	status = lxdata(context)->link_v.link
	    (lxdata(context)->link_v.data, &text, unit + 1);
	if (status) {
	    status = _libx1f4i0_lxdata_stat_link(context);
	    if (1) {
		break;
	    }
	}

	l_TEXT(text, output);

	if (ever < lead) {
	    memcpy(text, data + lead, size);
	    memcpy((char *) text + size, data, ever + 1);
	} else {
	    memcpy(text, data + lead, unit);
	}

	data = text;
	data += unit;
	*data = 0;
    } while (0);

    return status;
}
