/*
 * lxdata-p.d.c
 * Copyright (C) 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>
#include <lxcall.h>
#include <lxdata-inter.h>
#include <lxdata-types.h>

#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

#define l_DATA(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdata_d_pending(void *context, void *output, void **input)
{
    int status;
    void *data;

    status = x1f4_line_lxdata(context, &data);
    if (status) {
    } else {
	char *text;

	text = I_TEXT(*input);

	status = _libx1f4i0_lxdata_bill_text
	    (context, data, strlen(text), text);
	if (status) {
	} else {
	    struct lxdata_type *lxdata_data;

	    lxdata_data = context;

	    status = _libx1f4i0_lxcall_near_node
		(&lxdata_data->link_v, &lxdata_data->link_e,
		 lxdata_data->link_t.datatype, data);
	    if (status) {
		_libx1f4i0_lxdata_slip_data(context, &data);
	    } else {
		l_DATA(data, output);
	    }
	}
    }

    return status;
}
