/*
 * lxline-a.u.c
 * Copyright (C) 2008-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <cl.h>
#include <copy.h>
#include <e4.h>
#include <lxlead.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>
#include <nt.h>

#define club(miss)			((unsigned *) (miss))

#define byte(miss)			((unsigned char *) (miss))

#define becca(context) \
    ((void **) (context))
#define scope(context) \
    (becca((context)) + 2)
#define track(context) \
    (becca((context)) + 3)
#define frame(context) \
    (becca((context)) + 4)
#define class(context) \
    (becca((context)) + 5)

int
_libx1f4i0_lxline_copy_link(void *context, void *line, const void *data)
{
    int status;
    struct lxline_type *lxline_data;
    unsigned link;

    link = effect_link(data);

    lxline_data = *becca(context);

#if SIZEOF_UNSIGNED == 4
    club(line)[0] = club(data)[0];
    club(line)[1] = club(data)[1];
#else
    byte(line)[0] = byte(data)[0];
    byte(line)[1] = byte(data)[1];
    byte(line)[2] = byte(data)[2];
    byte(line)[3] = byte(data)[3];
    byte(line)[4] = byte(data)[4];
    byte(line)[5] = byte(data)[5];
    byte(line)[6] = byte(data)[6];
    byte(line)[7] = byte(data)[7];
#endif				/* SIZEOF_UNSIGNED == 4 */

    do {
	line = byte(line) + 8;

	if (~link) {
	    struct lxtext_type *lxtext_link;

	    lxtext_link =
		(struct lxtext_type *) lxline_data->link_f.text + link;

	    if (x1f4_pull_lxlead
		(*track(context), line, byte(data) + 8,
		 &status, *frame(context),
		 (struct x1f4_caselink_type **) class(context),
		 &lxtext_link->lxtype, lock_excase(*scope(context)))) {
		if (status) {
		} else {
		}

		break;
	    }
	}

	status = 0;

	{
#if defined copy_trap
	    copy_trap(line, byte(data) + 8);
#else
	    unsigned type;

	    type = effect_type(data);

	    copy_miss(line, type, byte(data) + 8);
#endif				/* copy_trap */
	}
    } while (0);

    return status;

}
