/*
 * lxline-b.0-s.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxline-config.h>

#include <e4.h>
#include <lxcall.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define I_BILL(t)			(*((X1f4_E4_C_BILL *) (t)))
#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

#define l_BILL(e, output) \
    {									      \
	X1f4_E4_C_BILL *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

#define byte(miss)			((unsigned char *) (miss))

int
_libx1f4i0_lxline_0_point_b(void *context, void *output, void **input)
{
    int status;
    const char *lift;
    struct cxseek_type *cxseek_data;
    struct dxline_type *dxline_data;
    unsigned size;
    void *data;

    cxseek_data = context;

    dxline_data = I_LINE(input[1]);

    status = cxseek_data->seek
	(dxline_data->line, I_TEXT(input[2]), &data, &lift, &size);
    if (status) {
	unsigned type;

	type = byte(data)[0] << 030 | byte(data)[1] << 020
	    | byte(data)[2] << 010 | byte(data)[3];
	if (type != X1f4_E4_BILL) {
	    status = _libx1f4i0_lxline_stat_trip
		(cxseek_data->line, lift, size, type, X1f4_E4_BILL);
	} else {
	    struct lxline_type *lxline_data;

	    lxline_data = cxseek_data->line;

	    status = _libx1f4i0_lxcall_swap_text
		(&lxline_data->ever_a, input[3], (void *) lift, size + 1);
	    if (status) {
	    } else {
		l_BILL(I_BILL(byte(data) + 8), input[0]);
		l_MODE(1, output);
	    }
	}
    } else {
	if (0) {
	} else {
	    l_MODE(0, output);
	    if (1) {
		status = 0;
	    }
	}
    }

    return status;
}
