/*
 * lxline-b.e.0.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxline-config.h>

#include <e4.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define I_BILL(t)			(*((X1f4_E4_C_BILL *) (t)))
#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_BILL(e, output) \
    {									      \
	X1f4_E4_C_BILL *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

#define byte(miss)			((unsigned char *) (miss))

int
_libx1f4i0_lxline_e0class_b(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxline_type *dxline_data;
    void *data;

    cxbend_data = context;

    dxline_data = I_LINE(input[1]);

    status = cxbend_data->pick(dxline_data->line, &data);
    if (status) {
	status = _libx1f4i0_lxline_stat_line(cxbend_data->line, 0, status);
    } else {
	unsigned type;

	type = byte(data)[0] << 030 | byte(data)[1] << 020
	    | byte(data)[2] << 010 | byte(data)[3];
	if (type != X1f4_E4_BILL) {
	    status = _libx1f4i0_lxline_stat_ends
		(cxbend_data->line, cxbend_data->bend, type, X1f4_E4_BILL);
	} else {
	    X1f4_E4_C_BILL fast;

	    fast = I_BILL(byte(data) + 8);

	    status = cxbend_data->slip(dxline_data->line);
	    if (status) {
		status = _libx1f4i0_lxline_stat_line
		    (cxbend_data->line, 0, status);
	    } else {
		dxline_data->size--;

		if (0) {
		} else {
		    l_BILL(fast, input[0]);
		    l_BILL(fast, output);
		}
	    }
	}
    }

    return status;
}
