/*
 * lxline-c.t.1.c
 * Copyright (C) 2013-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <copy.h>
#include <e4.h>
#include <exerrors.h>
#include <lxcast.h>
#include <lxline-inter.h>

static int line_trap(void *, void *, void **);

static int
line_trap(void *context, void *output, void **input)
{
    int status;
    struct lxline_type *lxline_data;
    struct x1f4_function_type *function_data;
    unsigned count;

    lxline_data = context;

    function_data = ((void **) input[-1])[X1f4_E4_RENDITION];

    status = 0;

    count = function_data->count - 1;
    if (count) {
	const int *args;
	struct x1f4_dxcast_type dxcast;
	void *miss, *slip[3];

	args = function_data->args;

	slip[0] = *input;
	slip[2] = &miss;

	miss = &dxcast;

	do {
	    slip[1] = *++input;
	    args += 2;
	    dxcast.type = *args;
	    if (dxcast.type == X1f4_E4_CASE) {
		slip[2] = *++input;
		status = _libx1f4i0_lxline_l_derived(lxline_data, NULL, slip);
		slip[2] = &miss;
	    } else {
		copy_miss(&dxcast.data, dxcast.type, *++input);
		status = _libx1f4i0_lxline_l_derived(lxline_data, NULL, slip);
	    }
	    if (status) {
		break;
	    }
	} while (count -= 2);
    }

    return status;
}


int
_libx1f4i0_lxline_t1centric(void *context, void *output, void **input)
{
    int status;

    do {
	const int *args;
	struct lxline_type *lxline_data;
	struct x1f4_function_type *function_data;
	unsigned count;

	lxline_data = context;

	function_data = ((void **) input[-1])[X1f4_E4_RENDITION];

	count = function_data->count;

	if (count & 1) {
	} else {
	    status = _libx1f4i0_lxline_stat_even(lxline_data);
	    if (1) {
		break;
	    }
	}

	args = function_data->args + 1;
	for (--count; count; count -= 2) {
	    if (*args != X1f4_E4_TEXT) {
		break;
	    } else {
		args += 2;
	    }
	}
	if (count) {
	    status = _libx1f4i0_lxline_stat_lock
		(lxline_data, function_data->count - count);
	    if (1) {
		break;
	    }
	}

	status = line_trap(context, output, input);
    } while (0);

    return status;
}
