/*
 * lxline-t.j.c
 * Copyright (C) 2008-2015, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxline-drive.h>
#include <lxline-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

#define byte(miss)			((unsigned char *) (miss))

int
_libx1f4i0_lxline_j_class_t(void *context, void *output, void **input)
{
    int status;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    lxline_data = lxtext_data->text;

    dxline_data = I_LINE(input[1]);

    status = _libx1f4i0_find_sfnote
	(dxline_data->line, I_TEXT(input[2]), &data);
    if (status) {
	unsigned type;

	status = 0;

	type = effect_type(data);
	if (type != X1f4_E4_TEXT) {
	    l_MODE(0, output);
	    if (1) {
		status = 0;
	    }
	} else {
	    X1f4_E4_C_TEXT post;

	    l_MODE(1, output);

	    post = I_TEXT(byte(data) + 8);

	    status = _libx1f4i0_lxcall_swap_text
		(&lxline_data->ever_a, *input, post, strlen(post) + 1);
	}
    } else {
	l_MODE(0, output);
    }

    return status;
}
