/*
 * lxlist-t.q.0.c
 * Copyright (C) 2008-2011, 2013-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>
#include <lxcall.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

#define I_LIST(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

#define byte(miss)			((unsigned char *) (miss))

int
_libx1f4i0_lxlist_q0class_t(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxlist_type *dxlist_data;
    struct lxlist_type *lxlist_data;
    void *data;

    cxbend_data = context;

    lxlist_data = cxbend_data->list;

    dxlist_data = I_LIST(input[0]);

    status = cxbend_data->pick(dxlist_data->list, &data);
    if (status) {
	status = _libx1f4i0_lxlist_stat_list(lxlist_data, 0, status);
    } else {
	unsigned type;

	type = byte(data)[0] << 030 | byte(data)[1] << 020
	    | byte(data)[2] << 010 | byte(data)[3];
	if (type != X1f4_E4_TEXT) {
	    status = _libx1f4i0_lxlist_stat_ends
		(lxlist_data, cxbend_data->bend, type, X1f4_E4_TEXT);
	} else {
	    const char *lift;

	    lift = I_TEXT(byte(data) + 8);
	    status = x1f4_auto_text
		(&lxlist_data->link_v, &lxlist_data->link_e, lift,
		 strlen(lift), output);
	}
    }

    return status;
}
