/*
 * qscc.8.c
 * Copyright (C) 2008-2012, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qscc-config.h>

#include <stddef.h>

#include <qscc-defs.h>
#include <qscc-inter.h>
#include <qscc-names.h>
#include <qscc-types.h>

#define qsrate(qsrate)			((struct qsrate_type *) (qsrate))

int
x1f4_high_qsrate(void *qsrate)
{
    int status;

    status = _libx1f4l2_ceil_qsrate(qsrate);
    if (status) {
    } else {
	qsrate(qsrate)->link_e.fplink_data = NULL;
	qsrate(qsrate)->link_e.fplink_text = NULL;

	qsrate(qsrate)->link_a.fplist.size = 0;

#if __MICRO_RATES__
	if (1) {
#elif 0
	}
#else
	if (qsrate(qsrate)->link_a.fplist.rate) {
#endif				/* __MICRO_RATES__ */
	    unsigned line;
	    void *data;

	    data = qsrate(qsrate)->link_a.fplist.fpnode;

	    line = qsrate(qsrate)->link_a.fplist.line;
#if __MICRO_RATES__
	    while (~line & 2) {
		line >>= 1;
	    }
#endif				/* __MICRO_RATES__ */

	    status = qsrate(qsrate)->link_m.mode
		(qsrate(qsrate)->link_m.data, &data,
		 qsrate(qsrate)->link_a.fplist.mall * 3 * line >> 1);
	    if (status) {
		status = MODE_ERROR;
	    } else {
		qsrate(qsrate)->link_a.fplist.rate = 0;
		if (1) {
		    qsrate(qsrate)->link_a.fplist.fpnode = data;
		}
	    }
	}
    }

    return status;
}
