/*
 * sstring.n-i.c
 * Copyright (C) 2006-2008, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#if !defined LIBx1f4i0
# include <cstring.nf.h>
#endif				/* !LIBx1f4i0 */
#if defined LIBx1f4i0
# include <inter.h>
#endif				/* LIBx1f4i0 */

#define C_TYPE_X(___c_type_x, ___c) \
    ((___c_type_x)[(___c) >> 5] & 1 << ((___c) & 31))

static const char escapes[] = "abtnvfr";
static const unsigned c_type_0[] = {
/*
 * . . . . . . .               . .
 * . . . . . . . . . . . . . . . .
 *
 *
 *
 *
 *
 *                               .
 * . . . . . . . . . . . . . . . .
 * . . . . . . . . . . . . . . . .
 * . . . . . . . . . . . . . . . .
 * . . . . . . . . . . . . . . . .
 * . . . . . . . . . . . . . . . .
 * . . . . . . . . . . . . . . . .
 * . . . . . . . . . . . . . . . .
 * . . . . . . . . . . . . . . . .
 */
/* *INDENT-OFF* */
    0xffffc07f, 0x00000000, 0x00000000, 0x80000000,
    0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff
/* *INDENT-ON* */
}, c_type_1[] = {
/*
 *               . . . . . . .
 *
 *     "
 *
 *
 *                         \
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 */
/* *INDENT-OFF* */
    0x00003f80, 0x00000004, 0x10000000, 0x00000000,
    0x00000000, 0x00000000, 0x00000000, 0x00000000
/* *INDENT-ON* */
};

void
x1f4_nprint_isstring(unsigned *put, const char *name, unsigned size,
		     const unsigned *c_type_x)
{
    unsigned c_type_2[8], miss = ~0;

    c_type_2[0] = c_type_1[0] | c_type_x[0];
    c_type_2[1] = c_type_1[1] | c_type_x[1];
    c_type_2[2] = c_type_1[2] | c_type_x[2];
    c_type_2[3] = c_type_1[3] | c_type_x[3];
    c_type_2[4] = c_type_1[4] | c_type_x[4];
    c_type_2[5] = c_type_1[5] | c_type_x[5];
    c_type_2[6] = c_type_1[6] | c_type_x[6];
    c_type_2[7] = c_type_1[7] | c_type_x[7];

    while (size) {
	unsigned byte;

	size--;

	byte = *(const unsigned char *) name;
	name++;

	if (C_TYPE_X(c_type_0, byte)) {
	    if (~miss) {
		x1f4_nflush_cstring(put, 0, &miss);
	    }
	    if (byte < 64) {
		miss = byte;
	    } else {
		*put += 4;
	    }
	} else {
	    if (~miss) {
		x1f4_nflush_cstring(put, 0x2f < byte && byte < 0x38, &miss);
	    }
	    if (C_TYPE_X(c_type_2, byte)) {
		*put += 2;
	    } else {
		*put += 1;
	    }
	}
    }
    if (~miss) {
	if (1) {
	    if (1) {
		x1f4_nflush_cstring(put, 0, &miss);
	    }
	}
    }
}
